function Create(self)
	self.ShootTimer = Timer()
	self.BurstTimer = Timer()
	self.BursterTimer = Timer()
	self.Burst = false
	self.Ammo = 0
	
	self.DamageCount = 100
	
	self.swingTimer = Timer()
	self.swing = true
	
	self.FlippTimer = Timer()
	self.aim = self.RotAngle
	self.HealthTimer = Timer()
	self.LastHealthTimer = Timer()
	self.Hit = 0
	self.LastHealth = 100
	
	self.DeathTime = 0
	self.Control = 100
	
	--mails self.attachable handler
	local i = 1;
	while i < MovableMan:GetMOIDCount() do
		if MovableMan:GetMOFromID(i).RootID == self.ID and i ~= self.ID then
			self.att = MovableMan:GetMOFromID(i)
			if string.find(self.att.PresetName, "Ronin head") then
				self.head = ToAttachable(self.att)
			end
		end
		i = i + 1
	end
	--mails self.attachable handler
	local i = 1;
	while i < MovableMan:GetMOIDCount() do
		if MovableMan:GetMOFromID(i).RootID == self.ID and i ~= self.ID then
			self.att = MovableMan:GetMOFromID(i)
			if string.find(self.att.PresetName, "Manta Helmet A") then
				self.helm = ToAttachable(self.att)
			end
		end
		i = i + 1
	end
	i = 1;
	while i < MovableMan:GetMOIDCount() do
		if MovableMan:GetMOFromID(i).RootID == self.ID and i ~= self.ID then
			self.att = MovableMan:GetMOFromID(i)
			if string.find(self.att.PresetName, "Engine") then
				self.Engine = ToAttachable(self.att)
			end
		end
		i = i + 1
	end
	--randomised frames
	self.head.Frame = math.random(0,5)
	if math.random(0,1) == 0 then
    self.head.Frame = math.random(6,9)
  end
	self.helm.Frame = math.random(0,2)
	if self.head.Frame == 1 then
    self.helm.Frame = math.random(3 ,5)
  end
  if math.random(0,3) == 0 then
    self.helm.ToDelete = true
  end
	self.Frame = math.random(0,2)
	self.EngineFrame = math.random(0,1)
	self.Engine.GetsHitByMOs = false
  self.EngineAngle = 0
  self.LastRot = 0
  self.water = false
  self.waterTimer = Timer()
  
  self.waterCheckTimer = Timer()
  for actor in MovableMan.Particles do
    if string.find(actor.PresetName, "Water Element") or string.find(actor.PresetName, "Lava Element") then
      self.water = true
    end
  end
  self.Ana = false
--  self.EngineFrame = 1
--  self.Frame = 1
--  self.head.Frame = 6
--  self.helm.Frame = 1
end

function Destroy(self)
	if MovableMan:ValidMO(self.Barrel) then
		self.Barrel.ToDelete = true
	end
end

function Update(self)
  if self.waterCheckTimer:IsPastSimMS(1000) then
    self.waterCheckTimer:Reset()
    self.water = false
    for actor in MovableMan.Particles do
      if string.find(actor.PresetName, "Water Element") or string.find(actor.PresetName, "Lava Element") then
        self.water = true
      end
    end
  end
  if self.DamageCount < 0 then
    self.Health = self.Health + 1 * (math.ceil(self.DamageCount * 100) * 0.01)
    self.DamageCount = self.DamageCount + 100
  end
  if math.abs(self.Vel.X) < 10 then
    if self.Vel.X > 0.1 then
      self.Vel.X = self.Vel.X - 0.01
    end
    if self.Vel.X < -0.1 then
      self.Vel.X = self.Vel.X + 0.01
    end
    if not self:GetController():IsState(Controller.MOVE_LEFT) and not self:GetController():IsState(Controller.MOVE_RIGHT) then
      if self.Vel.X > 0.1 then
        self.Vel.X = self.Vel.X - 0.01
      end
      if self.Vel.X < -0.1 then
        self.Vel.X = self.Vel.X + 0.01
      end
      self.Vel.X = self.Vel.X * 0.9999
    end
  end
  self.Vel.X = self.Vel.X * 0.99999
  if self.DeathTime == 0 then
   if self.LastHealthTimer:IsPastSimMS(1000) then
      if self.Health + 2 < self.LastHealth then
        self.Hit = 1
      end
      self.LastHealthTimer:Reset()
      self.LastHealth = self.Health
    end
    self.Hit = self.Hit + 0.1 / (10 + math.abs(self.Vel.X))
    if math.abs(self.Vel.X) < 20 then
      self.Hit = self.Hit / (1 + math.abs(self.Vel.X)*0.0005)
    else
      self.Hit = self.Hit / 1.01
    end
    if self.Health < 100 then
      if self.HealthTimer:IsPastSimMS((self.Health^2 * (0.5 + 200 / self.Hit^3) + 50) * 0.08) then
        self.Health = self.Health + 1
        self.LastHealth = self.LastHealth + 1
        self.HealthTimer:Reset()
      end
    elseif self.Health ~= 100 then
      self.Health = 100
      self.HealthTimer:Reset()
    end
  end
--  self.Engine.Frame = self.EngineFrame
  local gunAim = 0
  if self:GetController():IsMouseControlled() == true or self.Ana then
    self.aim = self:GetController().AnalogAim.AbsRadAngle
   if self.HFlipped then
      self.aim = math.min(math.max(self.aim - 3.14, self.RotAngle-0.2), self.RotAngle+1)
      gunAim = math.min(math.max(self.aim, self.RotAngle-0.2), self.RotAngle+1)
   else
      self.aim = math.min(math.max(self.aim, self.RotAngle-1.0), self.RotAngle+0.2)
      gunAim = math.min(math.max(self.aim, self.RotAngle-1.0), self.RotAngle+0.2)
   end
  else
    if self.HFlipped then
     if self:GetController():IsState(Controller.MOVE_UP) then
        self.aim = self.aim - 0.04
     elseif self:GetController():IsState(Controller.MOVE_DOWN) then
        self.aim = self.aim + 0.04
     end
    else
     if self:GetController():IsState(Controller.MOVE_UP) then
        self.aim = self.aim + 0.04
     elseif self:GetController():IsState(Controller.MOVE_DOWN) then
        self.aim = self.aim - 0.04
     end
    end
   
    if self:GetController().AnalogAim.AbsRadAngle ~= 0 then
      self.Ana = true
    end
   if self.HFlipped then
      self.aim = math.min(math.max(self.aim, self.RotAngle-0.2), self.RotAngle+1)
      gunAim = math.min(math.max(self.aim, self.RotAngle-0.2), self.RotAngle+1)
   else
      self.aim = math.min(math.max(self.aim, self.RotAngle-1.0), self.RotAngle+0.2)
      gunAim = math.min(math.max(self.aim, self.RotAngle-1.0), self.RotAngle+0.2)
   end
  end
  local speed = self.Vel.Magnitude * math.cos(math.abs(self.Vel.AbsRadAngle - self.RotAngle))
  self.ViewPoint = self.Pos + Vector(math.cos(self.RotAngle) * speed * 10, 0)
  local GunOffset = self.Pos + self:RotateOffset(Vector(28, 17))
	-- Validate barrel
	if not MovableMan:ValidMO(self.Barrel) or self.Barrel.PresetName ~= "Auto Barrel Waterproof" then
		self.Barrel = CreateMOSRotating("Auto Barrel Waterproof", "Manta.rte")
		MovableMan:AddParticle(self.Barrel)
		self.Barrel.Pos = GunOffset + (self.Vel * 0.001)
		self.Barrel.RotAngle = gunAim + (self.AngularVel * 0.001)
		self.Barrel.HFlipped = self.HFlipped
	end
  local angle = self.RotAngle
  if self:GetController():IsState(Controller.MOVE_RIGHT) then
    angle = angle - (angle + 0.35) * 0.8
  end
  if self:GetController():IsState(Controller.MOVE_LEFT) then
    angle = angle + (0.35 - angle) * 0.8
  end
	if self:IsPlayerControlled() then
		-- Double or tripple tapp movement keys to flipp
		if self.flipp ~= 0 and (self.FlippTimer:IsPastRealMS(500) or (self.FlippTimer:IsPastRealMS(1000) and self.Ana)) then
			self.flipp = 0
		end
		if self.JetMode == false then
      if self.HFlipped then
        if self:GetController():IsState(Controller.PRESS_RIGHT) then
          self.FlippTimer:Reset()
          self.flipp = self.flipp + 1
          if self.flipp > 1 then
            self.flipp = nil
          end
        end
        if self:GetController():IsState(Controller.PRESS_LEFT) then
          self.FlippTimer:Reset()
          self.flipp = self.flipp - 1
          if self.flipp < -1 then
            self.flipp = 0
            self.JetMode = true
            self.SecondaryTimer:Reset()
            self:SetNextFrame()
            self.landingMode = false
            sound = true
          end
        end
      else
        if self:GetController():IsState(Controller.PRESS_LEFT) then
          self.FlippTimer:Reset()
          self.flipp = self.flipp - 1
          if self.flipp < -1 then
            self.flipp = nil
          end
        end
        if self:GetController():IsState(Controller.PRESS_RIGHT) then
          self.FlippTimer:Reset()
          self.flipp = self.flipp + 1
          if self.flipp > 1 then
            self.flipp = 0
            sound = true
          end
        end
      end
		else
      if self.HFlipped then
        if self:GetController():IsState(Controller.PRESS_RIGHT) then
          self.FlippTimer:Reset()
          self.flipp = self.flipp + 1
          if self.flipp > 1 then
            self.flipp = 0
            self.JetMode = false
            self.Rebalanced = false
          end
        end
      elseif self:GetController():IsState(Controller.PRESS_LEFT) then
        self.FlippTimer:Reset()
        self.flipp = self.flipp - 1
        if self.flipp < -1 then
          self.flipp = 0
          self.JetMode = false
          self.Rebalanced = false
        end
      end
    end
    
		if not self.flipp then
			self.HFlipped = not self.HFlipped
			self.flipp = 0
			self.aim = self.aim * -1
		end
  end
  if self.BurstTimer:IsPastSimMS((self.Ammo)) and self:GetController():IsState(Controller.WEAPON_FIRE) then
    self.BursterTimer:Reset()
    self.Burst = true
  end
  if not self.BursterTimer:IsPastSimMS(250) and self.ShootTimer:IsPastSimMS(50) and self.Burst then
    self.ShootTimer:Reset()
    self.BurstTimer:Reset()
    
    local Shot = CreateAEmitter("Auto Cannon Shot", "Manta.rte")
    Shot.Pos = GunOffset + self.Barrel:RotateOffset(Vector(16, 1))
    if self.HFlipped then
      Shot.RotAngle = gunAim + 3.14
    else
      Shot.RotAngle = gunAim
    end
    Shot.Vel = self.Vel + self.Barrel:RotateOffset(Vector(70, 0)) 	-- Inherit velocity
    MovableMan:AddParticle(Shot)
    self.Ammo = self.Ammo + 120
    self.Hit = self.Hit / 1.1
  end
  if self.Ammo > 0 then
    self.Ammo = self.Ammo - 2
    if self.BurstTimer:IsPastSimMS((self.Ammo^0.9)) then
      self.Ammo = self.Ammo - 4
    end
    if self.BurstTimer:IsPastSimMS((self.Ammo^0.99)) then
      self.Ammo = self.Ammo * 0.99
    end
    if self.BurstTimer:IsPastSimMS((self.Ammo)) then
      self.Ammo = self.Ammo - 10
    end
  else
    self.Ammo = 0
  end
  self.AngularVel = self.AngularVel - ((self.RotAngle + self.AngularVel) * 0.02)
  self.AngularVel = self.AngularVel * 0.99
  self.RotAngle = self.RotAngle * 0.99
  local strength = 1
  local air = self:GetAltitude(1000,3) + math.sin(self.RotAngle) * 20
  local sizething = 600 / (20 + (self.Vel.X^2 + self.Vel.Y^2))
  if SceneMan:FindAltitude(self.Pos + self:RotateOffset(Vector(35 - sizething, 0)), 1000, 5) < air then
    air = SceneMan:FindAltitude(self.Pos + self:RotateOffset(Vector(35 - sizething, 0)), 1000, 5)
  end
  if SceneMan:FindAltitude(self.Pos + self:RotateOffset(Vector(-35 + sizething, 0)), 1000, 5) < air then
    air = SceneMan:FindAltitude(self.Pos + self:RotateOffset(Vector(-35 + sizething, 0)), 1000, 5)
  end
  if self:GetController():IsState(Controller.BODY_JUMP) then
    strength = strength + 1
  end
  if self:GetController():IsState(Controller.BODY_CROUCH) then
    strength = strength - 1
    if air > 50 and self.Vel.Y < 10 then
      self.Vel.Y = self.Vel.Y * 0.95 + 0.5
    end
    self.AngularVel = self.AngularVel - ((self.RotAngle + self.AngularVel) * 0.02)
    self.AngularVel = self.AngularVel * 0.99
    self.RotAngle = self.RotAngle * 0.95
  end
  local Upthing = false
  local downthing = false
  local leftthing = false
  local rightthing = false
  if self.DeathTime == 0 then
    if SceneMan:CastStrengthSumRay(self.Pos, self.Pos + Vector(0,30),0,0) ~= 0 then
      self.Pos.Y = self.Pos.Y - 1
    end
    if SceneMan:CastStrengthSumRay(self.Pos, self.Pos + Vector(0,40),0,0) ~= 0 then
      Upthing = true
    end
    if SceneMan:CastStrengthSumRay(self.Pos, self.Pos + Vector(0,-30),0,0) ~= 0 then
      self.Pos.Y = self.Pos.Y + 1
    end
    if SceneMan:CastStrengthSumRay(self.Pos, self.Pos + Vector(0,-40),0,0) ~= 0 then
      downthing = true
    end
    if SceneMan:CastStrengthSumRay(self.Pos, self.Pos + Vector(50,0),0,0) ~= 0 then
      self.Pos.X = self.Pos.X - 1
      if SceneMan:CastStrengthSumRay(self.Pos, self.Pos + Vector(35,0),0,0) ~= 0 then
        leftthing = true
        self.Pos.X = self.Pos.X - 0.5
        if SceneMan:CastStrengthSumRay(self.Pos, self.Pos + Vector(25,0),0,0) ~= 0 then
          leftthing = true
          self.Pos.X = self.Pos.X - 0.5
          self.DamageCount = self.DamageCount - 20
        end
      end
    end
    if SceneMan:CastStrengthSumRay(self.Pos, self.Pos + Vector(-50,0),0,0) ~= 0 then
      self.Pos.X = self.Pos.X + 1
      if SceneMan:CastStrengthSumRay(self.Pos, self.Pos + Vector(-35,0),0,0) ~= 0 then
        rightthing = true
        self.Pos.X = self.Pos.X + 0.5
        if SceneMan:CastStrengthSumRay(self.Pos, self.Pos + Vector(-25,0),0,0) ~= 0 then
          leftthing = true
          self.Pos.X = self.Pos.X + 0.5
          self.DamageCount = self.DamageCount + 20
        end
      end
    end
  end
  if Upthing == true and downthing == true then
    self.DamageCount = self.DamageCount - ((self.Vel.X^2 + self.Vel.Y^2)^0.35) * 4
  end
  if leftthing == true and rightthing == true then
    self.DamageCount = self.DamageCount - ((self.Vel.X^2 + self.Vel.Y^2)^0.35) * 4
  end
  local abovewater = false
  if self.water == true and air + self.Pos.Y > WaterHeight then
    waterAltitude = WaterHeight - self.Pos.Y
    abovewater = true
    if self.waterTimer:IsPastRealMS(waterAltitude^4.8 * 0.000000002 + 10) then
      self.waterTimer:Reset()
      local part = CreateMOPixel("Water Splash");
      part.Pos = Vector(self.Pos.X, WaterHeight) + Vector(math.random(-200000 / (1600 + waterAltitude^2) - 30, 200000 / (1600 + waterAltitude^2) + 30),0);
      part.Vel.X = math.random(-30000 / (1600 + waterAltitude^1.5), 30000 / (1600 + waterAltitude^1.5))
      part.Vel.Y = math.random(1000 / (420 + waterAltitude^1.2), 2000 / (420 + waterAltitude))
      --Add the particle to the world.
			MovableMan:AddParticle(part);
    end
    air = WaterHeight - self.Pos.Y
    if self.Pos.Y + self.Vel.Y > WaterHeight then
      self.Vel.Y = self.Vel.Y * 0.995
      self.Vel = self.Vel * 0.999
      self.Vel.Y = self.Vel.Y - 0.8
    end
    if self.Pos.Y + self.Vel.Y * 10 > WaterHeight - 20 and self.Vel.Y > 0 then
      self.Vel.Y = self.Vel.Y * 0.9995
      self.Vel.Y = self.Vel.Y - 0.2
      if self.Pos.Y + self.Vel.Y * 7 > WaterHeight - 10 then
        self.Vel.Y = self.Vel.Y * 0.999
        self.Vel.Y = self.Vel.Y - 0.4
        if self.Pos.Y + self.Vel.Y * 5 > WaterHeight - 5 then
          self.Vel.Y = self.Vel.Y * 0.995
          self.Vel.Y = self.Vel.Y - 0.6
        end
      end
    end
  end
  if self.Vel.Y > 0 then
    if self:GetController():IsState(Controller.BODY_CROUCH) then
      self.Vel.Y = self.Vel.Y * 0.9995
      if self.Vel.Y > 0 and self.Vel.Y^0.3 * 30 + 10000 > air^2 then
        self.Vel.Y = self.Vel.Y * (1 - (self.Vel.Y^0.3 * 30 + 10000 - air^2) * 0.0001 / (5 + self.Vel.Y^0.5))
      end
    else
      self.Vel.Y = self.Vel.Y * 0.98
      if self.Vel.Y > 0 and self.Vel.Y^0.3 * 30 + 10000 > air^2 then
        self.Vel.Y = self.Vel.Y * (1 - (self.Vel.Y^0.3 * 30 + 10000 - air^2) * 0.0002 / (10 + self.Vel.Y^0.5))
      end
    end
    self.AngularVel = self.AngularVel - ((self.RotAngle + self.AngularVel) * 0.2)
    self.AngularVel = self.AngularVel * 0.99
  else
    self.Vel.Y = self.Vel.Y * 0.999
  end
  if air < 50 then
    air = 50
  end
  air = air * self.Control * 0.01 - 100 + self.Control
  local power = 0
  local waterpower = 0
  local Xpower = 0
  local fan = math.cos(self.RotAngle)
  if fan < 0 then
    fan = 0
  end
  if strength == 0 then
    if air == 50 then
      power = 0 - (50000 / ((air^2.85 + 2000))^0.9) * fan
    elseif air < 100 then
      power = 0 - (50000 / ((air^2.85 + 2000))^0.9) * fan + 0.6
    elseif air < 150 then
      power = 0 - (50000 / ((air^2.85 + 2000))^0.9) * fan + 1
    elseif air < 200 then
      power = 0 - (50000 / ((air^2.85 + 2000))^0.9) * fan + 1
    else
      power = 0 - (50000 / ((air^2.85 + 2000))^0.9) * fan + 1.1
    end
    if abovewater then
      waterpower = 0 - (30000 / ((air^2.85 + 2000))^0.9) * fan
    end
    Xpower = 0 - (50000 / ((air^2.55 + 2000))^0.9) * fan
  elseif strength == 1 then
    if self.Vel.Y < 0 then
      self.Vel.Y = self.Vel.Y * 0.999
    end
    power = 0 - (50000 / ((air^2.65 + 2000))^0.9) * fan
    Xpower = 0 - (50000 / ((air^2.30 + 2000))^0.9) * fan
  elseif strength == 2 then
    power = 0 - (50000 / ((air^2.5 + 750))^0.9) * fan - 0.2
    Xpower = 0 - (50000 / ((air^2.2 + 750))^0.9) * fan
  end
  if self:GetController():IsState(Controller.MOVE_LEFT) or self:GetController():IsState(Controller.MOVE_RIGHT) then
    self:AddAbsForce(Vector(math.sin(angle) * Xpower * 0.6, math.cos(angle) * power) * 13000 + Vector(0,math.cos(angle) * waterpower) * 13000, self.Pos)
  else
    self:AddAbsForce(Vector(0, math.cos(angle) * power) * 13000, self.Pos)
  end
--  self.Vel.Y = self.Vel.Y + power * math.cos(self.RotAngle)
--  self.Vel.X = self.Vel.X + power * math.sin(self.RotAngle
  if abovewater and waterAltitude < 30 then
    self.Vel.X = self.Vel.X * 0.99
  end
  if self:GetController():IsState(Controller.MOVE_RIGHT) then
    self.Vel.X = self.Vel.X + 0.384
    if self.Vel.X < 10 then
      self.Vel.X = self.Vel.X + 0.648
    end
    if self.Vel.X < 5 then
      self.Vel.X = self.Vel.X + 0.864
    end
    if self.Vel.X < 0 then
      self.Vel.X = self.Vel.X + 1.104
    end
    self.AngularVel = self.AngularVel - 0.025
    self.AngularVel = self.AngularVel - ((self.RotAngle + self.AngularVel) + 0.45) * 0.9
  end
  if self:GetController():IsState(Controller.MOVE_LEFT) then
    self.Vel.X = self.Vel.X - 0.384
    if self.Vel.X > -10 then
      self.Vel.X = self.Vel.X - 0.648
    end
    if self.Vel.X > -5 then
      self.Vel.X = self.Vel.X - 0.864
    end
    if self.Vel.X > 0 then
      self.Vel.X = self.Vel.X - 1.104
    end
    self.AngularVel = self.AngularVel + 0.025
    self.AngularVel = self.AngularVel + (0.45 - (self.RotAngle + self.AngularVel)) * 0.9
  end
  self.Vel.X = self.Vel.X * (0.995 - math.abs(self.Vel.X) * 0.0000025)

	-- Update barrel
	self.Barrel.Pos = GunOffset
	self.Barrel.RotAngle = gunAim
	self.Barrel.HFlipped = self.HFlipped
  
  self.EngineAngle = self.EngineAngle - (self.LastRot - self.RotAngle)
  
  if self:GetController():IsMouseControlled() == false then
    self.aim = self.aim - (self.LastRot - self.RotAngle)
  end
  
  self.LastRot = self.RotAngle
  
  local engyangle = self.RotAngle
  if self:GetController():IsState(Controller.MOVE_RIGHT) then
    engyangle = engyangle - (angle + 0.55) * 0.8
  end
  if self:GetController():IsState(Controller.MOVE_LEFT) then
    engyangle = engyangle + (0.55 - angle) * 0.8
  end
  
  if self:GetController():IsState(Controller.MOVE_LEFT) or self:GetController():IsState(Controller.MOVE_RIGHT) then
    if self.EngineAngle > engyangle + 0.04 then
      self.EngineAngle = self.EngineAngle - 0.04
    elseif self.EngineAngle < engyangle - 0.04 then
      self.EngineAngle = self.EngineAngle + 0.04
    end
  else
    if self.EngineAngle > 0.04 then
      self.EngineAngle = self.EngineAngle - 0.04
    elseif self.EngineAngle < -0.04 then
      self.EngineAngle = self.EngineAngle + 0.04
    end
  end
	self.Engine.RotAngle = self.EngineAngle
	if self.Health < 5 then
    if self.Health > 0 then
      self.Health = 0
    end
    self.DeathTime = self.DeathTime + 5 - self.Health
    if self.Control > 0 then
      self.Control = self.Control + 2
    end
  end
  if self.DeathTime > 1000 then
    self:GibThis()
  end
end